%define 	pname ucspi-tcp
%define 	pversion 0.88
%define		bversion 236
%define 	rpmrelease iworx

%define		iworxdir /home/interworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_rhe_6x   0
%define		build_rhe_7x   0
%define		build_rhe_8x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}
%{?_with_rhe8x: 	%{expand: %%define build_rhe_8x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%ifarch x86_64
	%define optflags -pipe -m64
%else
	%define	optflags -pipe
%endif

# Distro Statements
%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_8x}
%define		oscode rhe8x
%define 	ostype Almalinux 8.x
BuildRequires:	zlib-devel
BuildRequires:	libnsl2-devel
Requires:	zlib
BuildRequires:	perl
Requires:	perl
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	tcpserver and tcpclient for building TCP client-server apps
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	D. J. Bernstein

Group:		System/Servers
Source0:	ucspi-tcp-%{pversion}.tar.bz2
URL:		http://cr.yp.to/ucspi-tcp.html

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	    Paul Oehler <poehler@interworx.com>

Buildroot:	%{_tmppath}/%{pname}-%{version}

Obsoletes:	ucspi-tcp-toaster

Source1:	ucspi-tcp-%{pversion}-man.tar.bz2
Patch0:		ucspi-tcp-toaster-04182004.patch.bz2
Patch1:		rblsmtpd-nodefaultrbl.patch
Patch2:         ucspi-tcp-0.88-ipv6.diff19.bz2

%description
tcpserver and tcpclient are easy-to-use command-line tools for building TCP
client-server applications. tcpserver waits for incoming connections  and,
for each  connection, runs a program  of  your  choice.  Your  program
receives  environment  variables showing the local and remote host names,
IP addresses, and port numbers. tcpserver offers a concurrency  limit to
protect  you from  running out of processes and memory.   When you  are
handling 40 (by default) simultaneous connections, tcpserver smoothly defers
acceptance of new connections. tcpserver   also   provides   TCP  access
control   features,  similar  to tcp-wrappers/tcpd's hosts.allow but much
faster.  It's access control rules are compiled into a  hashed format  with
cdb,  so it  can easily  deal with thousands of different hosts. This package
includes  a  recordio  tool  that  monitors all the input and output of a
server. tcpclient makes a TCP connection and runs a program of your choice.
It sets up the same environment variables as tcpserver. This package includes
several sample clients built on top of tcpclient: who@, date@, finger@, http@,
tcpcat, and mconnect. tcpserver  and tcpclient conform to  UCSPI, the UNIX
Client-Server Program Interface, using the TCP protocol.  UCSPI  tools are
available for several different networks.

%package        doc
Summary:        Ucspi-tcp Documentation
Group:          Documentation
Obsoletes:	ucspi-tcp-toaster-doc

%description    doc
Tcpserver documentation (man pages): it waits for  incoming connections and,
for each connection, runs a program of your choice.   Your program receives
environment variables showing the local and remote host names, IP addresses,
and port numbers.

%prep

if [ -n %{buildroot} ] ; then rm -rf %{buildroot} ; fi

if [ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} ; fi

%setup -q
%patch0 -p0
%patch1 -p1
%patch2 -p1


# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file
if [ -f %{_tmppath}/%{pname}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{pname}-%{pversion}-gcc ; fi

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{pname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{pname}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{pname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{pname}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{pname}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{pname}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)
if [ -f %{_tmppath}/%{pname}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{pname}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{pname}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{pname}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{pname}-%{pversion}-show_flags
%{_tmppath}/%{pname}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{pname}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{pname}-%{pversion}-show_flags ; fi

%build

if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi

mkdir -p %{buildroot}

# We have gcc written in a temp file
echo "`cat %{_tmppath}/%{pname}-%{pversion}-gcc` %{ccflags}"    >conf-cc
echo "`cat %{_tmppath}/%{pname}-%{pversion}-gcc` -s %{ldflags}" >conf-ld

# Delete gcc temp file
if [ -f %{_tmppath}/%{pname}-%{pversion}-gcc ] ; then rm -f %{_tmppath}/%{pname}-%{pversion}-gcc ; fi

echo "%{_prefix}" >conf-home

# Socket.lib FIX
echo "Fixing socket.lib"
perl -pi -e 's|`cat socket.lib`|-lnsl -lm -lz|g' $RPM_BUILD_DIR/%{pname}-%{pversion}/Makefile

# GLIBC fix
echo "Fixing errno.h for new GLIBC"
echo "#include <errno.h>" >> error.h

make

%install

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/{man5,man8}
install -m 755 addcr argv0 date@ delcr finger@ fixcrio http@ mconnect \
  mconnect-io rblsmtpd recordio tcpcat tcpclient tcprules tcprulescheck \
  tcpserver who@ %{buildroot}%{_bindir}
cd $RPM_BUILD_DIR
tar xvfj %{SOURCE1}
cd ucspi-tcp-%{pversion}-man
install -m 644 *.5 %{buildroot}%{_mandir}/man5
install -m 644 *.8 %{buildroot}%{_mandir}/man8

%clean
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
if [ -d $RPM_BUILD_DIR/%{pname}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{pname}-%{pversion} ; fi
if [ -d $RPM_BUILD_DIR/%{pname}-%{pversion}-man ] ; then rm -rf $RPM_BUILD_DIR/%{pname}-%{pversion}-man ; fi

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: ucspi-tcp package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%files doc
%attr(0644,root,root) %{_mandir}/man5/tcp-qualify.5*
%attr(0644,root,root) %{_mandir}/man8/addcr.8*
%attr(0644,root,root) %{_mandir}/man8/argv0.8*
%attr(0644,root,root) %{_mandir}/man8/date@.8*
%attr(0644,root,root) %{_mandir}/man8/delcr.8*
%attr(0644,root,root) %{_mandir}/man8/finger@.8*
%attr(0644,root,root) %{_mandir}/man8/fixcrio.8*
%attr(0644,root,root) %{_mandir}/man8/http@.8*
%attr(0644,root,root) %{_mandir}/man8/mconnect.8*
%attr(0644,root,root) %{_mandir}/man8/rblsmtpd.8*
%attr(0644,root,root) %{_mandir}/man8/recordio.8*
%attr(0644,root,root) %{_mandir}/man8/tcpcat.8*
%attr(0644,root,root) %{_mandir}/man8/tcpclient.8*
%attr(0644,root,root) %{_mandir}/man8/tcprules.8*
%attr(0644,root,root) %{_mandir}/man8/tcprulescheck.8*
%attr(0644,root,root) %{_mandir}/man8/tcpserver.8*
%attr(0644,root,root) %{_mandir}/man8/who@.8*

%files

%defattr (-,root,root)
%attr(0644,root,root) %doc CHANGES README TODO VERSION
%attr(0755,root,root) %{_bindir}/addcr
%attr(0755,root,root) %{_bindir}/argv0
%attr(0755,root,root) %{_bindir}/date@
%attr(0755,root,root) %{_bindir}/delcr
%attr(0755,root,root) %{_bindir}/finger@
%attr(0755,root,root) %{_bindir}/fixcrio
%attr(0755,root,root) %{_bindir}/http@
%attr(0755,root,root) %{_bindir}/mconnect
%attr(0755,root,root) %{_bindir}/mconnect-io
%attr(0755,root,root) %{_bindir}/rblsmtpd
%attr(0755,root,root) %{_bindir}/recordio
%attr(0755,root,root) %{_bindir}/tcpcat
%attr(0755,root,root) %{_bindir}/tcpclient
%attr(0755,root,root) %{_bindir}/tcprules
%attr(0755,root,root) %{_bindir}/tcprulescheck
%attr(0755,root,root) %{_bindir}/tcpserver
%attr(0755,root,root) %{_bindir}/who@

%changelog
* Mon Sep 20 2021 Joseph Purkis <jpurkis@interworx.com>
- Adding Almalinux build
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Tue May 22 2012 Paul Oehler <poehler@interworx.com>
- Removed dependency on libmysqlclient.
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Tue Sep 14 2010 Paul Oehler <poehler@interworx.com>
- Added ipv6 support
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Mon Jul 13 2009 Paul Oehler <poehler@interworx.com>
- added rblsmtpd-nodefaultrbl.patch
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Tue Feb 08 2005 Chris Wells <clwells@nexcess.net>
- Added fdr30 / fdr40
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
